package org.drools.cep;

import java.util.*;
import org.drools.model.*;
import org.drools.modelcompiler.dsl.pattern.D;
import org.drools.model.Index.ConstraintType;
import java.time.*;
import java.time.format.*;
import java.text.*;
import org.drools.core.util.*;
import org.kie.hacep.sample.kjar.StockTickEvent;
import java.util.UUID;
import org.kie.remote.DroolsExecutor;
import org.kie.hacep.sample.kjar.Result;
import org.drools.model.Model;

public class RulesB3B1DB0632F3B1C43AC7D11E122555AB implements Model {

    public final static DateTimeFormatter DATE_TIME_FORMATTER = DateTimeFormatter.ofPattern(DateUtils.getDateFormatMask(),
                                                                                            Locale.ENGLISH);

    @Override
    public String getName() {
        return "org.drools.cep";
    }

    public static Date string_2_date(String s) {
        return GregorianCalendar.from(LocalDate.parse(s,
                                                      DATE_TIME_FORMATTER).atStartOfDay(ZoneId.systemDefault()))
                                .getTime();
    }

    /**
     * With the following expression ID:
     * org.drools.modelcompiler.builder.generator.DRLIdGenerator@4c6e3674
     */
    @Override
    public List<org.drools.model.Rule> getRules() {
        return rules;
    }

    @Override
    public List<org.drools.model.EntryPoint> getEntryPoints() {
        return Collections.emptyList();
    }

    @Override
    public List<org.drools.model.Global> getGlobals() {
        return globals;
    }

    @Override
    public List<org.drools.model.Query> getQueries() {
        return queries;
    }

    @Override
    public List<org.drools.model.TypeMetaData> getTypeMetaDatas() {
        return typeMetaDatas;
    }

    public static final org.drools.model.Query1Def<java.lang.String> queryDef_stockTickEventQuery = D.query("org.drools.cep",
                                                                                                            "stockTickEventQuery",
                                                                                                            java.lang.String.class,
                                                                                                            "companyName");

    final org.drools.model.Query query_stockTickEventQuery = query_stockTickEventQuery();

    private org.drools.model.Query query_stockTickEventQuery() {
        final org.drools.model.Variable<org.kie.hacep.sample.kjar.StockTickEvent> var_stock = D.declarationOf(org.kie.hacep.sample.kjar.StockTickEvent.class,
                                                                                                              DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE,
                                                                                                              "stock");
        org.drools.model.Query stockTickEventQuery_build = queryDef_stockTickEventQuery.build(D.pattern(var_stock).expr("19F7304943D3244F07C40F8807C9F23C",
                                                                                                                        queryDef_stockTickEventQuery.getArg1(),
                                                                                                                        (_this, companyName) -> org.drools.modelcompiler.util.EvaluationUtil.areNullSafeEquals(_this.getCompany(),
                                                                                                                                                                                                               companyName),
                                                                                                                        D.betaIndexedBy(java.lang.String.class,
                                                                                                                                        org.drools.model.Index.ConstraintType.EQUAL,
                                                                                                                                        DomainClassesMetadataB3B1DB0632F3B1C43AC7D11E122555AB.org_kie_hacep_sample_kjar_StockTickEvent_Metadata_INSTANCE.getPropertyIndex("company"),
                                                                                                                                        _this -> _this.getCompany(),
                                                                                                                                        companyName -> companyName),
                                                                                                                        D.reactOn("company")));
        return stockTickEventQuery_build;
    }

    List<org.drools.model.Query> queries = new ArrayList<>();

    List<org.drools.model.Global> globals = Collections.emptyList();

    List<org.drools.model.TypeMetaData> typeMetaDatas = Collections.emptyList();

    public static List<Rule> rulesList = Arrays.asList(RulesB3B1DB0632F3B1C43AC7D11E122555ABRuleMethods0.rule_StockAverage(),
                                                       RulesB3B1DB0632F3B1C43AC7D11E122555ABRuleMethods0.rule_StockLog());

    List<org.drools.model.Rule> rules = rulesList;

    {
        queries.add(query_stockTickEventQuery);
    }
}
